-> converted by Kyzer

/*
**	$VER: xfdmaster.i 38.3 (28.2.98)
**
**	Copyright  1994-98 by Georg Hrmann
**	All Rights Reserved
*/

OPT MODULE
OPT EXPORT
OPT PREPROCESS

MODULE 'exec/libraries', 'dos/dosextens', 'exec/execbase'

->======================================================================
-> Library Base
->======================================================================

OBJECT xfdmasterbase
  lib:lib
  seglist			-> PRIVATE
  dosbase:PTR TO doslibrary	-> may be used for I/O etc.
  firstslave:PTR TO xfdslave	-> list of available slaves
  firstforeman			-> PRIVATE
  minbuffersize			-> (V36) min. bufsize for xfdRecogBuffer()
  minlinkersize			-> (V36) min. bufsize for xfdRecogLinker()
  execbase:PTR TO execbase	-> (V38.2) cached for fast access
ENDOBJECT

CONST XFDM_VERSION=38	->for OpenLibrary()

#define XFDM_NAME 'xfdmaster.library'

->======================================================================
-> Object Types (V36)
->======================================================================

CONST XFDOBJ_BUFFERINFO  = 1	-> xfdBufferInfo structure
CONST XFDOBJ_SEGMENTINFO = 2	-> xfdSegmentInfo structure
CONST XFDOBJ_LINKERINFO  = 3	-> xfdLinkerInfo structure
CONST XFDOBJ_SCANNODE    = 4	-> (V37) xfdScanNode structure
CONST XFDOBJ_SCANHOOK    = 5	-> (V37) xfdScanHook structure
CONST XFDOBJ_MAX         = 5	-> PRIVATE

->======================================================================
-> Buffer Info
->======================================================================

#define maxspeciallen error

OBJECT xfdbufferinfo
  sourcebuffer		-> pointer to source buffer
  sourcebuflen		-> length of source buffer
  slave			-> PRIVATE
  packername		-> name of recognized packer
  packerflags:INT	-> flags for recognized packer
->UNION maxspeciallen	-> max. length of special info (eg. password)
  error:INT		-> error return code
  targetbuffer		-> pointer to target buffer
  targetbufmemtype	-> memtype of target buffer
  targetbuflen		-> full length of buffer
  targetbufsavelen	-> used length of buffer
  decraddress		-> address to load decrunched file
  jmpaddress		-> address to jump in file
  special		-> special decrunch info (eg. password)
  flags:INT		-> (V37) flags to influence recog/decr
  reserved0:INT		-> (V38) PRIVATE
  mintargetlen		-> (V38) required length of target buffer
  finaltargetlen	-> (V38) final length of decrunched file
  usertargetbuf		-> (V38) target buffer allocated by user
  usertargetbuflen	-> (V38) target buffer length
ENDOBJECT

->======================================================================
-> Segment Info
->======================================================================

OBJECT xfdsegmentinfo
  seglist		-> value received by LoadSeg()
  slave			-> PRIVATE
  packername		-> name of recognized packer
  packerflags:INT	-> flags for recognized packer
->UNION maxspeciallen	-> max. length of special info (eg. password)
  error:INT		-> error return code
  special		-> special decrunch info (eg. password)
  relmode:INT		-> (V34) relocation mode
  flags:INT		-> (V37) flags to influence recog/decr
ENDOBJECT

->======================================================================
-> Linker Info (V36)
->======================================================================

OBJECT xfdlinkerinfo
  buffer	-> pointer to buffer
  buflen	-> length of buffer
  linkername	-> name of recognized linker
  unlink	-> PRIVATE
  reserved:INT	-> set to NULL
  error:INT	-> error return code
  hunk1		-> PRIVATE
  hunk2		-> PRIVATE
  amount1 	-> PRIVATE
  amount2	-> PRIVATE
  save1		-> pointer to first unlinked file
  save2		-> pointer to second unlinked file
  savelen1	-> length of first unlinked file
  savelen2	-> length of second unlinked file
ENDOBJECT

->======================================================================
-> Scan Node (V37)
->======================================================================

OBJECT xfdscannode
  next		-> pointer to next xfdScanNode structure (or NULL)
  save		-> pointer to data
  savelen	-> length of data
  packername	-> name of recognized packer
  packerflags	-> flags for recognized packer
ENDOBJECT

->======================================================================
-> Scan Hook (V37)
->======================================================================

OBJECT xfdscanhook
  entry		-> entrypoint of hook code
  data		-> private data of hook
  todo		-> bytes still to scan (READ ONLY)
  scannode	-> found data right now (or NULL) (READ ONLY)
ENDOBJECT

->======================================================================
-> Error Codes
->======================================================================

ENUM	XFDERR_OK=0,		-> no error

XFDERR_NOMEMORY,		-> error allocating memory
XFDERR_NOSLAVE,			-> no slave entry in info structure
XFDERR_NOTSUPPORTED,		-> slave doesn't support called function
XFDERR_UNKNOWN,			-> unknown file
XFDERR_NOSOURCE,		-> no sourcebuffer/seglist specified
XFDERR_WRONGPASSWORD,		-> wrong password for decrunching
XFDERR_BADHUNK,			-> bad hunk structure
XFDERR_CORRUPTEDDATA,		-> crunched data is corrupted
XFDERR_MISSINGRESOURCE,		-> (V34) missing external resource (eg. libs)
XFDERR_WRONGKEY,		-> (V35) wrong 16/32 bit key
XFDERR_BETTERCPU,		-> (V37) better CPU required
XFDERR_HOOKBREAK,		-> (V37) hook caused break
XFDERR_DOSERROR,		-> (V37) dos error
XFDERR_NOTARGET,		-> (V38) no user target given
XFDERR_TARGETTOOSMALL,		-> (V38) user target is too small
XFDERR_TARGETNOTSUPPORTED,	-> (V38) user target not supported

XFDERR_UNDEFINEDHUNK=$1000,	-> (V34) undefined hunk type
XFDERR_NOHUNKHEADER,		-> (V34) file is not executable
XFDERR_BADEXTTYPE,		-> (V34) bad hunk_ext type
XFDERR_BUFFERTRUNCATED,		-> (V34) unexpected end of file
XFDERR_WRONGHUNKAMOUNT,		-> (V34) wrong amount of hunks
XFDERR_NOOVERLAYS,		-> (V36) overlays not allowed

XFDERR_UNSUPPORTEDHUNK=$2000,	-> (V34) hunk type not supported
XFDERR_BADRELMODE		-> (V34) unknown XFDREL_#? mode

->======================================================================
-> Relocation modes (V34)
->======================================================================

ENUM	XFDREL_DEFAULT=0,	-> use memory types given by hunk_header
	XFDREL_FORCECHIP,	-> force all hunks to chip ram
	XFDREL_FORCEFAST	-> force all hunks to fast ram

->======================================================================
-> Values for xfd??_PackerFlags
->======================================================================

ENUM	XFDPFB_RELOC,		-> relocatible file packer
	XFDPFB_ADDR,		-> absolute address file packer
	XFDPFB_DATA,		-> data file packer

	XFDPFB_PASSWORD,	-> packer requires password
	XFDPFB_RELMODE,		-> (V34) decruncher supports xfdsi_RelMode
	XFDPFB_KEY16,		-> (V35) packer requires 16 bit key
	XFDPFB_KEY32,		-> (V35) packer requires 32 bit key

	XFDPFB_RECOGLEN,	-> (V38) slave recognizes target lengths
	XFDPFB_USERTARGET,	-> (V38) slave supports user target buffer

	XFDPFB_EXTERN=15	-> (V37) PRIVATE

SET XFDPFF_RELOC, XFDPFF_ADDR, XFDPFF_DATA, XFDPFF_PASSWORD,
XFDPFF_RELMODE, XFDPFF_KEY16, XFDPFF_KEY32, XFDPFF_RECOGLEN,
XFDPFF_USERTARGET
CONST XFDPFF_EXTERN=32768

->======================================================================
-> Values for xfd??_Flags (V37)
->======================================================================

ENUM	XFDFB_RECOGEXTERN,	-> xfdRecog#?() uses external slaves
	XFDFB_RECOGTARGETLEN,	-> (V38) xfdRecogBuffer() uses only slaves
				-> that recognize target lengths
	XFDFB_RECOGUSERTARGET,	-> (V38) xfdRecogBuffer() uses only slaves
				-> that support user targets
	XFDFB_USERTARGET	-> (V38) xfdbi_DecrunchBuffer() decrunchs
				-> to given xfdbi_UserTarget

SET XFDFF_RECOGEXTERN, XFDFF_RECOGTARGETLEN,
XFDFF_RECOGUSERTARGET, XFDFF_USERTARGET

->======================================================================
-> Flags for xfdTestHunkStructureFlags() (V36)
->======================================================================

ENUM XFDTHB_NOOVERLAYS		-> abort on hunk_overlay ($3f5)

SET XFDTHF_NOOVERLAYS

->======================================================================
-> Flags for xfdStripHunks() (V36)
->======================================================================

ENUM	XFDSHB_NAME,		-> strip hunk_name ($3e8)
	XFDSHB_SYMBOL,		-> strip hunk_symbol ($3f0)
	XFDSHB_DEBUG		-> strip hunk_debug ($3f1)

SET XFDSHF_NAME, XFDSHF_SYMBOL, XFDSHF_DEBUG

->======================================================================
-> Flags for xfdScanData() (V37)
->======================================================================

ENUM	XFDSDB_USEEXTERN,	-> use external slaves for scanning
	XFDSDB_SCANODD		-> scan at odd addresses too

SET XFDSDF_USEEXTERN, XFDSDF_SCANODD

->======================================================================
-> Foreman
->======================================================================

OBJECT xfdforeman
  security	-> moveq #-1,d0 : rts
  id		-> set to XFDF_ID
  version:INT	-> set to XFDF_VERSION
  reserved:INT	-> not used by now, set to NULL
  next		-> PRIVATE
  seglist	-> PRIVATE
  firstslave	-> first slave (see below)
ENDOBJECT

CONST XFDF_ID="XFDF"

CONST XFDF_VERSION=1

->======================================================================
-> Slave
->======================================================================

#define scandata recogsegment
#define verifydata decrunchsegment

OBJECT xfdslave
  next:PTR TO xfdslave	-> next slave (or NULL)
  version:INT		-> set to XFDS_VERSION
  masterversion:INT	-> minimum XFDM_VERSION required
  packername		-> NULL-terminated name of packer
  packerflags:INT	-> flags for packer
  maxspeciallen:INT	-> max. length of special info (eg. password)
  recogbuffer		-> buffer recognition code (or NULL)
  decrunchbuffer	-> buffer decrunch code (or NULL)
->UNION scandata	-> (V37) XFDPFB_DATA: scan code (or NULL)
  recogsegment		-> segment recognition code (or NULL)
->UNION verifydata	-> (V37) XFDPFB_DATA: verify code (or NULL)
  decrunchsegment	-> segment decrunch code (or NULL)
  slaveid:INT		-> (V36) slave ID (only internal slaves)
  replaceid:INT		-> (V36) ID of slave to be replaced
  minbuffersize		-> (V36) min. bufsize for RecogBufferXYZ()
ENDOBJECT

CONST XFDS_VERSION=2

->======================================================================
-> Additional Recognition Results (V38)
->======================================================================

OBJECT xfdrecogresult
  mintargetlen		-> min. required length of target buffer
  finaltargetlen	-> final length of decrunched file
ENDOBJECT

->======================================================================
-> Internal Slave IDs (V36)
->======================================================================

CONST XFDID_BASE=$8000

#define XFDID_PowerPacker23			(XFDID_BASE+$0001)
#define XFDID_PowerPacker30			(XFDID_BASE+$0003)
#define XFDID_PowerPacker30Enc			(XFDID_BASE+$0005)
#define XFDID_PowerPacker30Ovl			(XFDID_BASE+$0007)
#define XFDID_PowerPacker40			(XFDID_BASE+$0009)
#define XFDID_PowerPacker40Lib			(XFDID_BASE+$000a)
#define XFDID_PowerPacker40Enc			(XFDID_BASE+$000b)
#define XFDID_PowerPacker40LibEnc		(XFDID_BASE+$000c)
#define XFDID_PowerPacker40Ovl			(XFDID_BASE+$000d)
#define XFDID_PowerPacker40LibOvl		(XFDID_BASE+$000e)
#define XFDID_PowerPackerData			(XFDID_BASE+$000f)
#define XFDID_PowerPackerDataEnc		(XFDID_BASE+$0010)
#define XFDID_ByteKiller13			(XFDID_BASE+$0011)
#define XFDID_ByteKiller20			(XFDID_BASE+$0012)
#define XFDID_ByteKiller30			(XFDID_BASE+$0013)
#define XFDID_ByteKillerPro10			(XFDID_BASE+$0014)
#define XFDID_ByteKillerPro10Pro		(XFDID_BASE+$0015)
#define XFDID_DragPack10			(XFDID_BASE+$0016)
#define XFDID_TNMCruncher11			(XFDID_BASE+$0017)
#define XFDID_HQCCruncher20			(XFDID_BASE+$0018)
#define XFDID_RSICruncher14			(XFDID_BASE+$0019)
#define XFDID_ANCCruncher			(XFDID_BASE+$001a)
#define XFDID_ReloKit10				(XFDID_BASE+$001b)
#define XFDID_HighPressureCruncher		(XFDID_BASE+$001c)
#define XFDID_STPackedSong			(XFDID_BASE+$001d)
#define XFDID_TSKCruncher			(XFDID_BASE+$001e)
#define XFDID_LightPack15			(XFDID_BASE+$001f)
#define XFDID_CrunchMaster10			(XFDID_BASE+$0020)
#define XFDID_HQCCompressor100			(XFDID_BASE+$0021)
#define XFDID_FlashSpeed10			(XFDID_BASE+$0022)
#define XFDID_CrunchManiaData			(XFDID_BASE+$0023)
#define XFDID_CrunchManiaDataEnc		(XFDID_BASE+$0024)
#define XFDID_CrunchManiaLib			(XFDID_BASE+$0025)
#define XFDID_CrunchManiaNormal			(XFDID_BASE+$0026)
#define XFDID_CrunchManiaSimple			(XFDID_BASE+$0027)
#define XFDID_CrunchManiaAddr			(XFDID_BASE+$0028)
#define XFDID_DefJamCruncher32			(XFDID_BASE+$0029)
#define XFDID_DefJamCruncher32Pro		(XFDID_BASE+$002a)
#define XFDID_TetraPack102			(XFDID_BASE+$002b)
#define XFDID_TetraPack11			(XFDID_BASE+$002c)
#define XFDID_TetraPack21			(XFDID_BASE+$002d)
#define XFDID_TetraPack21Pro			(XFDID_BASE+$002e)
#define XFDID_TetraPack22			(XFDID_BASE+$002f)
#define XFDID_TetraPack22Pro			(XFDID_BASE+$0030)
#define XFDID_DoubleAction10			(XFDID_BASE+$0031)
#define XFDID_DragPack252Data			(XFDID_BASE+$0032)
#define XFDID_DragPack252			(XFDID_BASE+$0033)
#define XFDID_FCG10				(XFDID_BASE+$0034)
#define XFDID_Freeway07				(XFDID_BASE+$0035)
#define XFDID_IAMPacker10ATM5Data		(XFDID_BASE+$0036)
#define XFDID_IAMPacker10ATM5			(XFDID_BASE+$0037)
#define XFDID_IAMPacker10ICEData		(XFDID_BASE+$0038)
#define XFDID_IAMPacker10ICE			(XFDID_BASE+$0039)
#define XFDID_Imploder				(XFDID_BASE+$003a)
#define XFDID_ImploderLib			(XFDID_BASE+$003b)
#define XFDID_ImploderOvl			(XFDID_BASE+$003c)
#define XFDID_FileImploder			(XFDID_BASE+$003d)
#define XFDID_MasterCruncher30Addr		(XFDID_BASE+$003f)
#define XFDID_MasterCruncher30			(XFDID_BASE+$0040)
#define XFDID_MaxPacker12			(XFDID_BASE+$0041)
#define XFDID_PackIt10Data			(XFDID_BASE+$0042)
#define XFDID_PackIt10				(XFDID_BASE+$0043)
#define XFDID_PMCNormal				(XFDID_BASE+$0044)
#define XFDID_PMCSample				(XFDID_BASE+$0045)
#define XFDID_XPKPacked				(XFDID_BASE+$0046)
#define XFDID_XPKCrypted			(XFDID_BASE+$0047)
#define XFDID_TimeCruncher17			(XFDID_BASE+$0048)
#define XFDID_TFACruncher154			(XFDID_BASE+$0049)
#define XFDID_TurtleSmasher13			(XFDID_BASE+$004a)
#define XFDID_MegaCruncher10			(XFDID_BASE+$004b)
#define XFDID_MegaCruncher12			(XFDID_BASE+$004c)
#define XFDID_ProPack				(XFDID_BASE+$004d)
#define XFDID_ProPackData			(XFDID_BASE+$004e)
#define XFDID_ProPackDataKey			(XFDID_BASE+$004f)
#define XFDID_STCruncher10			(XFDID_BASE+$0050)
#define XFDID_STCruncher10Data			(XFDID_BASE+$0051)
#define XFDID_SpikeCruncher			(XFDID_BASE+$0052)
#define XFDID_SyncroPacker46			(XFDID_BASE+$0053)
#define XFDID_SyncroPacker46Pro			(XFDID_BASE+$0054)
#define XFDID_TitanicsCruncher11		(XFDID_BASE+$0055)
#define XFDID_TitanicsCruncher12		(XFDID_BASE+$0056)
#define XFDID_TryItCruncher101			(XFDID_BASE+$0057)
#define XFDID_TurboSqueezer61			(XFDID_BASE+$0058)
#define XFDID_TurboSqueezer80			(XFDID_BASE+$0059)
#define XFDID_TurtleSmasher200			(XFDID_BASE+$005a)
#define XFDID_TurtleSmasher200Data		(XFDID_BASE+$005b)
#define XFDID_StoneCracker270			(XFDID_BASE+$005c)
#define XFDID_StoneCracker270Pro		(XFDID_BASE+$005d)
#define XFDID_StoneCracker292			(XFDID_BASE+$005e)
#define XFDID_StoneCracker299			(XFDID_BASE+$005f)
#define XFDID_StoneCracker299d			(XFDID_BASE+$0060)
#define XFDID_StoneCracker300			(XFDID_BASE+$0061)
#define XFDID_StoneCracker300Data		(XFDID_BASE+$0062)
#define XFDID_StoneCracker310			(XFDID_BASE+$0063)
#define XFDID_StoneCracker310Data		(XFDID_BASE+$0064)
#define XFDID_StoneCracker311			(XFDID_BASE+$0065)
#define XFDID_StoneCracker400			(XFDID_BASE+$0066)
#define XFDID_StoneCracker400Data		(XFDID_BASE+$0067)
#define XFDID_StoneCracker401			(XFDID_BASE+$0068)
#define XFDID_StoneCracker401Data		(XFDID_BASE+$0069)
#define XFDID_StoneCracker401Addr		(XFDID_BASE+$006a)
#define XFDID_StoneCracker401BetaAddr		(XFDID_BASE+$006b)
#define XFDID_StoneCracker403Data		(XFDID_BASE+$006c)
#define XFDID_StoneCracker404			(XFDID_BASE+$006d)
#define XFDID_StoneCracker404Data		(XFDID_BASE+$006e)
#define XFDID_StoneCracker404Addr		(XFDID_BASE+$006f)
#define XFDID_ChryseisCruncher09		(XFDID_BASE+$0070)
#define XFDID_QuickPowerPacker10		(XFDID_BASE+$0071)
#define XFDID_GNUPacker12			(XFDID_BASE+$0072)
#define XFDID_GNUPacker12Seg			(XFDID_BASE+$0073)
#define XFDID_GNUPacker12Data			(XFDID_BASE+$0074)
#define XFDID_TrashEliminator10			(XFDID_BASE+$0075)
#define XFDID_MasterCruncher30Data		(XFDID_BASE+$0076)
#define XFDID_SuperCruncher27			(XFDID_BASE+$0077)
#define XFDID_UltimatePacker11			(XFDID_BASE+$0078)
#define XFDID_ProPackOld			(XFDID_BASE+$0079)
#define XFDID_SACFPQCruncher			(XFDID_BASE+$007a)
#define XFDID_PowerPackerPatch10		(XFDID_BASE+$007b)
#define XFDID_CFP135				(XFDID_BASE+$007c)
#define XFDID_BOND				(XFDID_BASE+$007d)
#define XFDID_PowerPackerLoadSeg		(XFDID_BASE+$007e)
#define XFDID_StoneCracker299b			(XFDID_BASE+$007f)
#define XFDID_CrunchyDat10			(XFDID_BASE+$0080)
#define XFDID_PowerPacker20			(XFDID_BASE+$0081)
#define XFDID_StoneCracker403			(XFDID_BASE+$0082)
#define XFDID_PKProtector200			(XFDID_BASE+$0083)
